/*
 Echo por MoonMakers:
 Lo hicimos para aprender junto con la tecnologuia,

 El canal de youtube donde esta el tutorial: https://www.youtube.com/channel/UC0actK4-vYEXDyV7J_4vGrw
 

*/

#include <CurieBLE.h>

BLEPeripheral Granja;
BLEService Nerd("19b10010-e8f2-537e-4f6c-d104768a1214"); 

BLEUnsignedCharCharacteristic buttons("19b10011-e8f2-537e-4f6c-d104768a1214", BLERead | BLEWrite);

BLEUnsignedIntCharacteristic sensors("19b10012-e8f2-537e-4f6c-d104768a1214", BLERead | BLENotify);

#include "DHT.h"
#define DHTPIN 4
#define DHTTYPE DHT22
DHT dht(DHTPIN, DHTTYPE);

long previousMillis = 0;  

const int pinPWMA = 6;
const int pinAIN2 = 7;
const int pinAIN1 = 8;
//const int pinBIN1 = 9;
//const int pinBIN2 = 10;
//const int pinPWMB = 11;
const int pinSTBY = 12;

const int pinMotorA[3] = { pinPWMA, pinAIN2, pinAIN1 };

enum moveDirection {
   forward,
  
};
 
enum turnDirection {
   clockwise,
   counterClockwise
};
 
const int waitTime = 2000;   
const int speed = 200;      
 

const int green = 2; 

boolean a = LOW, b = LOW, Atuomatico = LOW, Atu = false; //Control variables
bool tiemposs = false;

long tiempo = 0;

long HPreMilis = 0;
long LPreMilis = 0;

long humedadMilis = 0;
long currentMillis = 0;
long luzMilis = 0;
int pinLDR = A5;
 int humdad = 0;
 int temp = 0;
 int valorLDR = 0;

 long Mtiempo = 0;

void setup() {
  Serial.begin(9600);
  dht.begin();//sensor begin
  pinMode(green, OUTPUT);
  //pinMode(red, OUTPUT);
  pinMode(pinLDR,INPUT);

   pinMode(pinAIN2, OUTPUT);
   pinMode(pinAIN1, OUTPUT);
   pinMode(pinPWMA, OUTPUT);

  Granja.setLocalName("Los granjeros neds");
  Granja.setAdvertisedServiceUuid(Nerd.uuid());

  Granja.addAttribute(Nerd);//service 
  Granja.addAttribute(buttons);// add the buttons characteristic
  Granja.addAttribute(sensors); // add the sensor characteristic

  // set the initial value for the characeristic:
  buttons.setValue(1);
  // begin advertising BLE Light service:
  Granja.begin();
  Serial.println("Nerd service begin!");
}

void loop() {
  // listen for BLE peripherals to connect:
  
  BLECentral central = Granja.central();
  digitalWrite(green, LOW);
  long tiempo = millis();
  // if a central is connected to peripheral:
  if (central) {
    Serial.print("Connected to central: ");
    // print the central's MAC address:
    Serial.println(central.address());

    // while the central is still connected to peripheral:
    while (central.connected()) {
      // if the remote device wrote to the characteristic,
      // use the value to control the leds:
      if (buttons.written()) {
        if (buttons.value() == '1' && a == LOW) { // 1 in ASCII

          digitalWrite(green, HIGH);         // will turn the LED on
          a = HIGH;
        } else if (buttons.value() == '1' && a == HIGH)  {  //when 1 was read again (second time)          

          digitalWrite(green, LOW);          // will turn the LED off
          a = LOW;
        }

        if (buttons.value() == '2' && b == LOW) { // 2 in ASCII
           Serial.print("Motor");
           enableMotors();
           move(forward, 180);
           b = HIGH;
        } else if (buttons.value() == '2' && b == HIGH)  { //when 2 was read again (second time)  

         fullStop();
          b = LOW;
        }

        if (buttons.value() == '3'){
          Fotoresestencia();
          }
          
         if (buttons.value() == '4' && Atu == false){
            Serial.print("Avilitando Automatico");
            Atuomatico = true; 
            Atu = true;
            Mtiempo = tiempo;
            }else if (buttons.value() == '4' && Atu == false){
            Atuomatico = false; 
            Atu = false;
              }
      }


     humedadMilis += 1;
     currentMillis += 1;
     luzMilis +=1;

      // if 10s have passed, check the sensor:
      if (currentMillis - previousMillis >= 13000) { //13 26 39 52 65 78 91
        previousMillis = currentMillis;
        updateSensor();
      }
       if (humedadMilis - HPreMilis >= 12000) {//12 24 36 48 60 72 84 96
        HPreMilis = humedadMilis;
        humdedad();
      }
     

      delay(1);
     tiempo = millis();

      if (Atuomatico == true ){
  
   valorLDR= analogRead(pinLDR);
   temp=dht.readTemperature();//read temperature 
   humdad = dht.readHumidity();
  
  if (valorLDR >= 651)digitalWrite(green, LOW);     
  if (valorLDR <= 650)digitalWrite(green, HIGH);    
 
  if ( tiempo - Mtiempo >= 15000 && tiemposs == false){
   Serial.print("prender motor");
   Mtiempo = tiempo;
   enableMotors();
   move(forward, 180);
    tiemposs = true; 
  }
  if( tiempo - Mtiempo >= 5000 && tiemposs == true ){
   Mtiempo = tiempo;
    fullStop();
    tiemposs = false;
  }
 
  }
      
      //finish
    }
    // when the central disconnects, print it out:
    Serial.print(F("Disconnected from central: "));
    Serial.println(central.address());
  }
  else
  {
    digitalWrite(green, LOW);
    //digitalWrite(red, LOW);
    humedadMilis = 0;
    currentMillis = 0;
    luzMilis = 0;
   
  }


  
}

void updateSensor() {
   temp=dht.readTemperature();//read temperature 
  sensors.setValue(temp);//send temperature value
  Serial.print("temperatura: ");//if you want check temperature i serial monitor
  Serial.print(temp);//if you want check temperature i serial monitor
  Serial.println();
}
void humdedad(){
   humdad = dht.readHumidity();
  sensors.setValue(humdad);
  Serial.print("humedad: ");
  Serial.print(humdad);
  Serial.println();
}
void Fotoresestencia(){
   valorLDR= analogRead(pinLDR);
   sensors.setValue(valorLDR);
   Serial.print("Luz: ");
   Serial.print(valorLDR);
   Serial.println();
  }

void move(int direction, int speed)
{
   if (direction == forward)
   {
      moveMotorForward(pinMotorA, speed);
     // moveMotorForward(pinMotorB, speed);
   }
 
}
 
void fullStop()
{
   disableMotors();
   stopMotor(pinMotorA);
   //stopMotor(pinMotorB);
}
 
//Funciones que controlan los motores
void moveMotorForward(const int pinMotor[3], int speed)
{
   digitalWrite(pinMotor[1], HIGH);
   digitalWrite(pinMotor[2], LOW);
 
   analogWrite(pinMotor[0], speed);
}
 
void stopMotor(const int pinMotor[3])//
{
   digitalWrite(pinMotor[1], LOW);
   digitalWrite(pinMotor[2], LOW);
 
   analogWrite(pinMotor[0], 0);
}
 
void enableMotors() //
{
   digitalWrite(pinSTBY, HIGH);
}
 
void disableMotors()
{
   digitalWrite(pinSTBY, LOW);
}

  
